# CHANGELOG

## [1.1.0]
### Requirements
* numpy >= 1.23.5

### Added
Features
* class `SeqDesign` for sequential training
* `Engine` can be built without a surrogate
* `BayesInference` and `BayesModelComparison` can be performed on an `Engine` object without a surrogate

Examples
* Example `user_guide` to go along with the user guide on the website
* Example `principal_component_analysis` to show application of pca on metamodel outputs
* Example 'only_model' for use of inference and model comparison without a metamodel

### Changed
* Moved functions for sequential training from `Engine` to `SeqDesign`
* Moved `hellinger_distance`, `logpdf`, `subdomain` into `surrogate_models/seq_design`
* Early stop in `BayesInf` for improved performance of `BayesModelComp`
* Allow singular matrices in exploitation with `BayesActDesign` 
* `ExpDesign.generate_ED` no longer needs `transform`

Bug fixes
* Import of `ExpDesign` allowed
* Images in `PostProcessing` only saved, not opened
* Fixed option `MetaModel.dim_red_method = 'pca'`


### Removed
* Disabled exploration with `voronoi`
* `BayesModelComp.just_n_meas`

## [1.0.0]
### Requirements
* numpy now at 1.23.3
* ....

### Added
Features
* PyLinkForwardModel has new link_type 'umbridge' for UM-Bridge type models
* class `InputSpace` as parent class to `ExpDesigns`
* `MetaModel` has option to train with OLS+constraints

Examples
* Example `umbridge_tsunamitutorial` to show two options of using UM-Bridge type models
* Example `convergence_tests` for the constraints

### Changed
General
* Independent functions moved out of classes
* Constructors of `PostProcessing`, `BayesInference`, `BayesModelComp` are to be given the engine instead of the metamodel
* Constructor of `Exploration` to be given `ExpDesigns` instead of `MetaModel`

Engine
* `MetaModelEngine` renamed to `Engine`
* Split `run()` into `train_normal()` and `train_sequential()`
* `opt_SeqDesign()` renamed to `choose_next_sample()`

MetaModel
* `MetaModel` fully independent of model
* `MetaModel` uses `InputSpace` instead of `ExpDesigns`
* `create_metamodel()` split into `build_metamodel()` and `fit()`
* `fit()` renamed to `regression()`
* `eval_metamodel()` only runs on given samples, full functionality retained in `Engine.eval_metamodel()`
* Polynomial related functions moved from `MetaModelEngine` to `MetaModel`

PyLinkForwardModel
* Read-in of MC-references now performed by `PyLinkForwardModel.read_observation()`

ExpDesigns
* Parameters related to sequential training were moved from `MetaModel` to `ExpDesigns` (`Seq*`, `valid_model_runs`)
 
### Removed
* Class `SequentialDesign`
* `ExpDesigns.method` 
* `MetaModel.create_basis_indices()`


